                PAGE    ,132
                TITLE   ENVARGS.ASM -- Environment variable, command line argument
                %OUT ENVARGS.ASM
                INCLUDE CONSTANT.INC

DONE            EQU     0H
NOTYET          EQU     0FFH

dsEnvArgs       SEGMENT PARA PUBLIC 'DATA'
; Constant
delimChars      DB      TAB, BLANK, COMMA, SQUORT, DQUORT, EOS
spaceChars      DB      BLANK, TAB, EOS
quortChars      DB      SQUORT, DQUORT, EOS
EnvDelimChars   DB      TAB, BLANK, EQUAL, EOS

; Save area
initFlag        DB      NOTYET  ; PSP segment information initialize flag
ptrPSP          DW      NULL    ; NULL    ; Segment of PSP
                DW      0       ; Offset of PSP
ptrENV          DW      NULL    ; NULL    ; Segment of Environment valiables,
                DW      0       ; Offset of Environment valiables,
EnvName         DW      NULL    ; SEGMENT:@Name
                DW      NULL    ; OFFSET :@Name
EnvValue        DW      NULL    ; SEGMENT:@Value
                DW      NULL    ; OFFSET :@Value
quort           DB      EOS     ; Quort chararacter
argc            DB      0       ; Number of args
argv            DW      MAXARGS DUP(0AAAAH) ; Pointer array
argDest         DW      NULL    ; SEGMENT arg destination address
                DW      NULL    ; OFFSET arg destination address
cmdBuf          DB      128 DUP('*'), EOS
saveAX          DW      NULL
dsEnvArgs       ENDS

stack           SEGMENT PARA STACK
                DB      20 DUP('@')
stack           ENDS

csEnvArgs       SEGMENT PARA PUBLIC 'EnvArgs'
                ASSUME  CS:csEnvArgs, DS:dsEnvArgs, SS:stack

;       getEnv -- Get value of environment valiable
;       ENTRY DS:[SI] : Point to environment valiable name
;             ES:[DI] : Point to value of environment valiable
;       RETURN CY = 0 : Environment Valiable exist
;              CY = 1 : Environment Valiable does not xist
;              ES:[DI] : Point to value of environment valiable
                PUBLIC  @@getEnv
@@getENV        PROC    FAR             ; getEnvName @Name @Valiable
                MOV     BP, SP
                PUSH    DS              ; Save current DS
                MOV     AX, SEG dsEnvArgs
                MOV     DS, AX
                CALL    initEnvArgs
                MOV     AX, SEG dsEnvArgs ; Save parameters
                MOV     DS, AX
                MOV     AX, [BP+8]      ; SEGMENT of @Name
                MOV     DS:EnvName, AX
                MOV     AX, [BP+10]     ; OFFSET of @Name
                MOV     DS:EnvName+2, AX
               
                MOV     AX, [BP+4]      ; SEGMENT of @Value 
                MOV     DS:EnvValue, AX
                MOV     ES, AX
                MOV     DI, [BP+6]      ; OFFET of @Value
                MOV     DS:EnvValue+2, DI
                MOV     BYTE PTR ES:[DI], EOS

                MOV     AX, DS:EnvName  ; ES:[DI] : Point to target environmrnt name
                MOV     ES, AX
                MOV     AX, DS:EnvName+2
                MOV     DI, AX
 
                MOV     AX, DS:ptrEnv+2 ; DS:[SI] : Point to environment string
                MOV     SI, AX
                MOV     AX, DS:ptrEnv
                MOV     DS, AX
 
                MOV     CX, DI          ; Save DI
getEnv3:
                CALL    compEnvName
                JNC     getEnv1
                CALL    skipToNextEnvName
                CMP     BYTE PTR DS:[SI], EOS
                JE      getEnv2
                MOV     DI, CX          ; Restore DI
                JMP     getEnv3
getEnv1:
                MOV     BX, SEG EnvValue
                MOV     ES, BX
                MOV     DI, ES:EnvValue+2
                MOV     BX, ES:EnvValue
                MOV     ES, BX
                CALL    copyEnvValue
getEnv2:
                POP     DS              ; Restore DS
                RET
@@getEnv        ENDP

;      getArgv -- Return pointer to argument
;      ENTRY  @index : Index of arguments
;      RETURN  @arg : Point to argument
                PUBLIC  @@getArgv
@@getArgv       PROC    FAR             ; getArgv @index @arg
                MOV     BP, SP
                PUSH    DS              ; Save DS
                MOV     AX, SEG dsEnvArgs
                MOV     DS, AX
                CALL    initEnvArgs
                MOV     AX, dsEnvArgs
                MOV     DS, AX

                MOV     AX, [BP+4]      ; SEGMENT @argv
                MOV     ES, AX
                MOV     DI, [BP+6]      ; OFFSET @argv

                MOV     argDest, ES     ; Save Arg buffer pointer
                MOV     argDest+2, DI
                MOV     BYTE PTR ES:[DI], EOS ; Set null string

                MOV     AX, [BP+8]      ; SEGMENT @index
                MOV     ES, AX
                MOV     DI, [BP+10]     ; OFFSET @index
                MOV     AL, BYTE PTR ES:[DI]
                CMP     AL, argc        ; Check out index range
                JG      getArgv1        ; Index too big

                CBW
                DEC     AX              ; Determein Argv pointer
                ADD     AX, AX
                ADD     AX, OFFSET argv
                MOV     SI, AX
                MOV     SI, [SI]        ; Source OFFSET
                
                MOV     AX, argDest     ; Restore arg destination SEGMENT
                MOV     ES, AX
                MOV     DI, argDest+2   ; Restore arg destination OFFSET
getArgv2:
                MOV     AL, BYTE PTR DS:[SI] ; Copy arg string
                MOV     BYTE PTR ES:[DI], AL
                CMP     AL, EOS
                JE      getArgv1
                INC     SI
                INC     DI
                JMP     getArgv2
getArgv1:
                POP     DS              ; Restore DS
                RET     8
@@getArgv       ENDP

;      getArgc -- Return number of arguments
;      ENTRY  ==NONE==
;      RETURN  ==NONE==
                PUBLIC  @@getArgc
@@getArgc       PROC    FAR             ; @argc
                MOV     BP, SP
                PUSH    DS
                MOV     AX, SEG dsEnvArgs
                MOV     DS, AX
                CALL    initEnvArgs
                MOV     AX, [BP+4]      ; SEGMENT @argc
                MOV     ES, AX
                MOV     DI, [BP+6]      ; OFFSET @argc
                MOV     AL, BYTE PTR argc
                MOV     BYTE PTR ES:[DI], AL
                POP     DS
                RET     4
@@getArgc       ENDP

;               initEnvArgs -- Initialize PSP and command line parameter work area
;               ENTRY   ==NONE==
;               RETURN  ==NONE==
initEnvArgs     PROC
                CMP     initFlag, DONE
                JE      initEnvArgs1
                CALL    getPSPSeg
                CALL    savePSPInfo
                CALL    initArgs
                MOV     initFlag, DONE  ; Initialization completed
initEnvArgs1:
                RET
initEnvArgs     ENDP

;        getPSPSeg -- Get PSP segment address
;        ENTRY === NONE ===
;        RETURN  ==NONE==
getPSPSeg       PROC
                MOV     AH, 62H
                INT     21H
                MOV     ptrPSP, BX
                RET
getPSPSeg       ENDP

;        savePSPInfo -- Save PSP addresses
;        ENTRY   ==NONE==
;        RETURN  ==NONE==
savePSPInfo     PROC
                MOV     AX, ptrPSP
                MOV     ES, AX
                MOV     AX, ES:[2CH]
                MOV     DI, OFFSET ptrEnv
                MOV     DS:[DI], AX     ; Save address of environment valuable area
                RET
savePSPInfo     ENDP
          
;        compEnvName -- Compare target environment name
;        ENTRY DS:[SI] -- Environment name should be refered
;              ES:[DI] -- Environment name to be compared
;        RETURN CY = 0 : Equivalent
;               CY = 1 : Not equivalent
compEnvName     PROC
compEnvName3:
                MOV     AL, BYTE PTR ES:[DI]
                CMP     AL, BYTE PTR DS:[SI]
                JNE     compEnvName1
                INC     SI
                INC     DI
                JMP     compEnvName3
compEnvName1:
                CMP     AL, EOS
                JNE     compEnvName5
                CALL    skipBlanks
                CMP     AL, EQUAL
                JNE     compEnvName5
                CLC
                JMP     compEnvName6
compEnvName5:
                STC
compEnvName6:
                RET
compEnvName     ENDP

;        copyEnvValue -- Copy environment variable value
;        ENTRY DS:[SI] : Point to environment variable source
;              ES:[DI] : Point to value buffer
copyEnvValue    PROC
                MOV     DX, DI          ; Save DI
                CALL    skipBlanks
                MOV     DI, DX
                CMP     AL, EQUAL    
                JNE     copyEnvValue1   ; Invalid format
                INC     SI
copyEnvValue2:
                MOV     AL, BYTE PTR DS:[SI]
                MOV     BYTE PTR ES:[DI], AL
                CMP     AL, EOS
                JE      copyEnvValue1
                INC     SI
                INC     DI
                JMP     copyEnvValue2
copyEnvValue1:
                RET
copyEnvValue    ENDP

;       skipToNextEnvName -- skip to next environment valiable name
;       ENTRY   DS:[SI] -- Environment staring
;       RETURN  DS:[SI] -- Point to next environment valiable name
skipToNextEnvName PROC
skipToNextEnvName2:
                MOV     AL, BYTE PTR DS:[SI]
                CMP     AL, EOS
                JE      skipToNextEnvName1
                INC     SI
                JMP     skipToNextEnvName2
skipToNextEnvName1:
                INC     SI
                RET
skipToNextEnvName ENDP


;       skipBlanks
;       ENTRY  DS:[SI] : Point to environmrnt string
;       RETURN DS:[SI] : Point to next NON-BLANK character
;              AL : Last character
skipBlanks      PROC
skipBlanks2:
                MOV     AL, BYTE PTR [SI]
                CMP     AL, EOS
                JE      skipBlanks1
                CALL    isSpace
                JC      skipBlanks1
                INC     SI
                JMP     skipBlanks2
skipBlanks1:
                RET
skipBlanks      ENDP

;       initArgs -- Initialize Command line parameter buffers
;       ENTRY   ==NONE==
;       RETURN  ==NONE==
initArgs        PROC
                CALL    copyCmdBuffer   ; Copy command line parameter string into local buffer
                MOV     argc, 0
                MOV     SI, OFFSET cmdBuf
initArg1:
                CALL    skipBlanks      ; Skip leading blanks
                CMP     AL, EOS         ; No more parameter
                JE      initArg2
                CMP     AL, COMMA
                JNE     initArg3
                CALL    saveArgPtr
                MOV     BYTE PTR [SI], EOS
                INC     SI
                JMP     initArg4
initArg3:
                CALL    isQuort
                JC      initArg5
                MOV     quort, AL
                INC     SI
                CALL    saveArgPtr
                CALL    findNextQuort
                MOV     BYTE PTR [SI], EOS
                INC     SI
                CALL    skipBlanks
                CMP     AL, COMMA
                JNE     initArg6
                INC     SI
initArg6:
                JMP     initArg4
initArg5:
                CALL    saveArgPtr
                CALL    findNextDelim
                MOV     BYTE PTR [SI], EOS
                INC     SI
                CALL    skipBlanks
                CMP     AL, COMMA
                JNE     initArg4
                INC     SI
initArg4:
                JMP     initArg1
initArg2:
                RET
initArgs        ENDP

;      saveArgPtr -- Save pointer to command line parameter
;                    and increment argment counter
;      ENTRY  ==NONE==
;      RETURN  ==NONE==
saveArgPtr      PROC
                MOV     AL, argc
                CMP     AL, MAXARGS
                JGE     saveArgPtr1
                CBW
                ADD     AX, AX
                MOV     DI, AX
                MOV     BX, OFFSET argv
                MOV     DS:[BX+DI], SI
                INC     argc            ; Count up argc
saveArgPtr1:
                RET
saveArgPtr      ENDP

;     isDelim -- Check delimiter character
;     ENTRY AL : Character to be tested
;     RETURN CY = 0 : Match delimiter chatcter
;            CY = 1 : Not match delimiter chatcter
isDelim         PROC
                PUSH    ES
                PUSH    DI
                MOV     BX, SEG dsEnvArgs
                MOV     ES, BX
                MOV     DI, OFFSET delimChars
                CALL    isChars
                POP     DI
                POP     ES
                RET
isDelim         ENDP
               
;     isSpace -- Check space character
;     ENTRY AL : Character to be tested
;     RETURN CY = 0 : Match space chatcter
;            CY = 1 : Not match space chatcter
isSpace         PROC
                PUSH    ES
                PUSH    DI
                MOV     BX, SEG dsEnvArgs
                MOV     ES, BX
                MOV     DI, OFFSET spaceChars
                CALL    isChars
                POP     DI
                POP     ES
                RET
isSpace         ENDP
               
;     isQuort -- Check quort character
;     ENTRY AL : Character to be tested
;     RETURN CY = 0 : Match quort chatctar
;            CY = 1 : Not match quort chatctar
isQuort         PROC
                PUSH    ES
                PUSH    DI
                MOV     BX, SEG dsEnvArgs
                MOV     ES, BX
                MOV     BX, OFFSET quortChars
                MOV     DI, BX
                CALL    isChars
                POP     DI
                POP     ES
                RET
isQuort         ENDP
               
;     isChars -- Finc character in character list
;     ENTRY AL : Character to be tested
;     RETUNR CY = 0 : Match chatacter in a list
;            CY = 1 : Do not match chatacter in a list
isChars         PROC
isChars2:
                CMP     BYTE PTR ES:[DI], EOS
                JE      isChars1
                CMP     AL, BYTE PTR ES:[DI]
                JE      isChars3
                INC     DI
                JMP     isChars2
isChars3:
                CLC
                JMP     isChars4
isChars1:
                STC
isChars4:
                RET
isChars         ENDP

;     findNextQuort -- Find next quort character point
;     ENTRY DS:[SI] : Point to the first character position
;     RETURN DS:[SI] : Point to the next quort character position 
;            AL : Last character
findNextQuort   PROC
findNextQuort2:
                MOV     AL, BYTE PTR [SI]
                CMP     AL, EOS
                JE      findNextQuort1
                CMP     AL, quort
                JE      findNextQuort1
                INC     SI
                JMP     findNextQuort2
findNextQuort1:
                RET
findNextQuort   ENDP

;       findNextDelim -- Find the next delimiter
;       ENTRY DS:[SI] : Point to the first character position
;       RETURN DS:[SI] : Point to the next delimiter position
;            AL : Last character
findNextDelim   PROC
findNextDelim2:
                MOV     AL, BYTE PTR [SI]
                CMP     AL, EOS
                JE      findNextDelim1
                CALL    isDelim
                JNC     findNextDelim1
                INC     SI
                JMP     findNextDelim2
findNextDelim1:
                RET
findNextDelim   ENDP

;               copyCmdBuffer -- Copy one comand line parameter
;               ENTRY  === NONE ===
;               RETURN === NONE === 
copyCmdBuffer   PROC
                PUSH    DS              ; Save DS
                MOV     AX, ptrPSP
                MOV     DS, AX
                MOV     CX, 0
                MOV     CL, BYTE PTR DS:[80H]
                MOV     AX, SEG cmdBuf
                MOV     ES, AX
                MOV     SI, 81H         ; Source SEGMENT:OFFSET
                MOV     DI, OFFSET cmdBuf
                CLD
                REP MOVS BYTE PTR ES:[DI], DS:[SI]
                MOV     BYTE PTR ES:[DI], EOS
                MOV     BYTE PTR ES:[DI+1], EOS
                POP     DS              ; Restore DS
                RET
copyCmdBuffer   ENDP
csEnvArgs       ENDS
                END
